import gtk



class Menu(gtk.Menu):

    def __init__(self, data):

        gtk.Menu.__init__(self)

        for entry in data:
            if (entry):
                icon, label, handler, args = entry
                if (icon):
                    mitem = gtk.ImageMenuItem(icon)
                    mitem.get_children()[0].set_label(label)
                else:
                    mitem = gtk.MenuItem(label)
                
                if (handler):
                    mitem.connect("activate", self.__on_activate,
                                  handler, args)

            else:
                mitem = gtk.MenuItem()
                
            mitem.show()
            self.add(mitem)
        #end for



    def __on_activate(self, src, handler, args):
        
        apply(handler, args)



    def popup(self, button, time):

        gtk.Menu.popup(self, None, None, None, button, time)
